## fenics-dolfinx 0.3.0

=== cpp/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Top level CMakeLists.txt file for DOLFINx
cmake_minimum_required(VERSION 3.16)

#------------------------------------------------------------------------------
# Set project name and version number

project(DOLFINX VERSION "0.3.0")

set(DOXYGEN_DOLFINX_VERSION ${DOLFINX_VERSION} CACHE STRING "Version for Doxygen" FORCE)

#------------------------------------------------------------------------------
# Use C++17
set(CMAKE_CXX_STANDARD 17)

# Require C++17
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Do not enable compler-specific extensions
set(CMAKE_CXX_EXTENSIONS OFF)

#------------------------------------------------------------------------------
# Get GIT changeset, if available

find_program(GIT_FOUND git)
if (GIT_FOUND)
  # Get the commit hash of the working branch
  execute_process(COMMAND git rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT_HASH
    OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else()
  set(GIT_COMMIT_HASH "unknown")
endif()

#------------------------------------------------------------------------------
# General configuration

# Set location of our FindFoo.cmake modules
set(CMAKE_MODULE_PATH "${DOLFINX_SOURCE_DIR}/cmake/modules")

# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfinx)

#------------------------------------------------------------------------------
# Configurable options for how we want to build

include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFINx with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFINx with shared libraries.")

option(DOLFINX_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages." OFF)
add_feature_info(DOLFINX_SKIP_BUILD_TESTS DOLFINX_SKIP_BUILD_TESTS "Skip build tests for testing usability of dependency packages.")

# Add shared library paths so shared libs in non-system paths are found
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")

# Enable SIMD with xtensor
option(XTENSOR_USE_XSIMD "Enable SIMD with xtensor." OFF)
add_feature_info(XTENSOR_USE_XSIMD XTENSOR_USE_XSIMD "Enable SIMD with xtensor (xsimd).")

# Enable xtensor with target-specific optimization, i.e. -march=native
option(XTENSOR_OPTIMIZE "Enable xtensor target-specific optimization" OFF)
add_feature_info(XTENSOR_OPTIMIZE XTENSOR_OPTIMIZE "Enable architecture-specific optimizations as defined by xtensor.")

#------------------------------------------------------------------------------
# Enable or disable optional packages

# List optional packages
list(APPEND OPTIONAL_PACKAGES "SLEPc")
list(APPEND OPTIONAL_PACKAGES "ParMETIS")
list(APPEND OPTIONAL_PACKAGES "KaHIP")

# Add options
foreach (OPTIONAL_PACKAGE ${OPTIONAL_PACKAGES})
  string(TOUPPER "DOLFINX_ENABLE_${OPTIONAL_PACKAGE}" OPTION_NAME)
  option(${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}." ON)
  add_feature_info(${OPTION_NAME} ${OPTION_NAME} "Compile with support for ${OPTIONAL_PACKAGE}.")
endforeach()

#------------------------------------------------------------------------------
# Check for MPI

# FIXME: Should we set CMake to use the discovered MPI compiler wrappers?
find_package(MPI 3 REQUIRED)

#------------------------------------------------------------------------------
# Compiler flags

# Default build type (can be overridden by user)
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "Choose the type of build, options are: Debug Developer MinSizeRel Release RelWithDebInfo." FORCE)
endif()

# Check for some compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-pipe HAVE_PIPE)
if (HAVE_PIPE)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -pipe)
endif()

# Add some strict compiler checks
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -Wextra -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -Wall;-Werror;-Wextra;-pedantic)
endif()

# Debug flags
CHECK_CXX_COMPILER_FLAG(-g HAVE_DEBUG)
if (HAVE_DEBUG)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -g)
endif()

# Optimisation
CHECK_CXX_COMPILER_FLAG(-O2 HAVE_O2_OPTIMISATION)
if (HAVE_O2_OPTIMISATION)
  list(APPEND DOLFINX_CXX_DEVELOPER_FLAGS -O2)
endif()

#------------------------------------------------------------------------------
# Run tests to find required packages

# Note: When updating Boost version, also update DOLFINXCongif.cmake.in
if(DEFINED ENV{BOOST_ROOT} OR DEFINED BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS on)
endif()
set(Boost_USE_MULTITHREADED $ENV{BOOST_USE_MULTITHREADED})
set(Boost_VERBOSE TRUE)
find_package(Boost 1.70 REQUIRED timer filesystem)
set_package_properties(Boost PROPERTIES TYPE REQUIRED
  DESCRIPTION "Boost C++ libraries"
  URL "http://www.boost.org")

# Check for required package xtensor
find_package(xtensor 0.23.10 REQUIRED)
set_package_properties(xtensor PROPERTIES TYPE REQUIRED
  DESCRIPTION "C++ library for numerical analysis with multi-dimensional array expressions."
  URL "https://xtensor.readthedocs.io/")

# Check for required package xtensor-blas
find_package(xtensor-blas REQUIRED)
set_package_properties(xtensor-blas PROPERTIES TYPE REQUIRED
  DESCRIPTION "BLAS extenssion to xtensor."
  URL "https://xtensor-blas.readthedocs.io/")

find_package(PETSc 3.10)
set_package_properties(PETSc PROPERTIES TYPE REQUIRED
  DESCRIPTION "Portable, Extensible Toolkit for Scientific Computation (PETSc)"
  URL "https://www.mcs.anl.gov/petsc/"
  PURPOSE "PETSc linear algebra backend")

# Check for HDF5
set(HDF5_PREFER_PARALLEL TRUE)
set(HDF5_FIND_DEBUG TRUE)
find_package(HDF5 REQUIRED COMPONENTS C)
if (NOT HDF5_IS_PARALLEL)
  message(FATAL_ERROR "Found serial HDF5 build, MPI HDF5 build required, try setting HDF5_DIR or HDF5_ROOT")
endif()
set_package_properties(HDF5 PROPERTIES TYPE REQUIRED
  DESCRIPTION "Hierarchical Data Format 5 (HDF5)"
  URL "https://www.hdfgroup.org/HDF5")

find_package(SCOTCH REQUIRED)
set_package_properties(SCOTCH PROPERTIES TYPE REQUIRED
  DESCRIPTION "Programs and libraries for graph, mesh and hypergraph partitioning"
  URL "https://www.labri.fr/perso/pelegrin/scotch"
  PURPOSE "Parallel graph partitioning and redordering")

# Check for required packages UFC and basix
find_package(Python3 COMPONENTS Interpreter REQUIRED)
find_package(UFC MODULE ${DOLFINX_VERSION_MAJOR}.${DOLFINX_VERSION_MINOR})
set_package_properties(UFC PROPERTIES TYPE REQUIRED
  DESCRIPTION "Unified interface for form-compilers (part of FFCx)"
  URL "https://github.com/fenics/ffcx")

find_package(Basix 0.0.1 REQUIRED)
set_package_properties(basix PROPERTIES TYPE REQUIRED
  DESCRIPTION "FEniCS tabulation library"
  URL "https://github.com/fenics/basix")

  get_target_property(BASIX_DEFN Basix::basix INTERFACE_COMPILE_DEFINITIONS)
  if("XTENSOR_USE_XSIMD" IN_LIST BASIX_DEFN)
    find_package(xsimd REQUIRED)
  endif()

  #------------------------------------------------------------------------------
# Run tests to find optional packages

# Check for SLEPc
set(SLEPC_FOUND FALSE)
if (DOLFINX_ENABLE_SLEPC)
  find_package(SLEPc 3.10)
  set_package_properties(SLEPc PROPERTIES TYPE OPTIONAL
    DESCRIPTION "Scalable Library for Eigenvalue Problem Computations"
    URL "http://slepc.upv.es/")
endif()

# Check for ParMETIS
if (DOLFINX_ENABLE_PARMETIS)
  find_package(ParMETIS 4.0.2)
  set_package_properties(ParMETIS PROPERTIES TYPE OPTIONAL
    DESCRIPTION "Parallel Graph Partitioning and Fill-reducing Matrix Ordering"
    URL "http://glaros.dtc.umn.edu/gkhome/metis/parmetis/overview"
    PURPOSE "Parallel graph partitioning")
endif()

# Check for KaHIP
if (DOLFINX_ENABLE_KAHIP)
  find_package(KaHIP)
  set_package_properties(KaHIP PROPERTIES TYPE OPTIONAL
    DESCRIPTION "A family of graph partitioning programs"
    URL "https://kahip.github.io/"
    PURPOSE "Parallel graph partitioning")
endif()

#------------------------------------------------------------------------------
# Print summary of found and not found optional packages

feature_summary(WHAT ALL)

#------------------------------------------------------------------------------
# Installation of DOLFINx library

add_subdirectory(dolfinx)

#------------------------------------------------------------------------------
# Generate and install helper file dolfinx.conf

# FIXME: Can CMake provide the library path name variable?
if (APPLE)
  set(OS_LIBRARY_PATH_NAME "DYLD_LIBRARY_PATH")
else()
  set(OS_LIBRARY_PATH_NAME "LD_LIBRARY_PATH")
endif()

# FIXME: not cross-platform compatible
# Create and install dolfinx.conf file
configure_file(${DOLFINX_SOURCE_DIR}/cmake/templates/dolfinx.conf.in
               ${CMAKE_BINARY_DIR}/dolfinx.conf @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dolfinx.conf
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/dolfinx
        COMPONENT Development)

#------------------------------------------------------------------------------
# Copy data in demo/test direcories to the build directories

set(GENERATE_DEMO_TEST_DATA FALSE)
if (Python3_Interpreter_FOUND AND (${DOLFINX_SOURCE_DIR}/demo IS_NEWER_THAN ${CMAKE_CURRENT_BINARY_DIR}/demo OR ${DOLFINX_SOURCE_DIR}/test IS_NEWER_THAN ${CMAKE_CURRENT_BINARY_DIR}/test))
  file(REMOVE_RECURSE ${CMAKE_CURRENT_BINARY_DIR}/demo ${CMAKE_CURRENT_BINARY_DIR}/test)
  set(GENERATE_DEMO_TEST_DATA TRUE)
endif()

if (GENERATE_DEMO_TEST_DATA)
  message(STATUS "")
  message(STATUS "Copying demo and test data to build directory.")
  message(STATUS "----------------------------------------------")
  execute_process(
    COMMAND ${Python3_EXECUTABLE} "-B" "-u" ${DOLFINX_SOURCE_DIR}/cmake/scripts/copy-test-demo-data.py ${CMAKE_CURRENT_BINARY_DIR} ${PETSC_SCALAR_COMPLEX}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    RESULT_VARIABLE COPY_DEMO_DATA_RESULT
    OUTPUT_VARIABLE COPY_DEMO_DATA_OUTPUT
    ERROR_VARIABLE COPY_DEMO_DATA_OUTPUT)
  if (COPY_DEMO_DATA_RESULT)
    message(FATAL_ERROR "Copy demo data failed: \n${COPY_DEMO_DATA_OUTPUT}")
  endif()
endif()

#------------------------------------------------------------------------------
# Generate form files for tests and demos

if (GENERATE_DEMO_TEST_DATA)
  message(STATUS "")
  message(STATUS "Generating form files in demo and test directories. May take some time...")
  message(STATUS "----------------------------------------------------------------------------------------")
  execute_process(
    COMMAND ${Python3_EXECUTABLE} "-B" "-u" ${DOLFINX_SOURCE_DIR}/cmake/scripts/generate-form-files.py ${PETSC_SCALAR_COMPLEX}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    RESULT_VARIABLE FORM_GENERATION_RESULT
    OUTPUT_VARIABLE FORM_GENERATION_OUTPUT
    ERROR_VARIABLE FORM_GENERATION_OUTPUT
    )

  if (FORM_GENERATION_RESULT)
    # Cleanup so that form generation is triggered next time we run cmake
    file(REMOVE_RECURSE ${CMAKE_CURRENT_BINARY_DIR}/demo ${CMAKE_CURRENT_BINARY_DIR}/test)
    message(FATAL_ERROR "Generation of form files failed: \n${FORM_GENERATION_OUTPUT}")
  endif()
endif()

#------------------------------------------------------------------------------
# Generate CMakeLists.txt files for demos if needed

# NOTE: We need to call this script after generate-formfiles

if (GENERATE_DEMO_TEST_DATA)
  message(STATUS "")
  message(STATUS "Generating CMakeLists.txt files in demo directory")
  message(STATUS "-------------------------------------------------------------------")
  # Generate CMakeLists.txt files in build directory
  execute_process(
    COMMAND ${Python3_EXECUTABLE} ${DOLFINX_SOURCE_DIR}/cmake/scripts/generate-cmakefiles.py
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    RESULT_VARIABLE CMAKE_GENERATION_RESULT
    OUTPUT_VARIABLE CMAKE_GENERATION_OUTPUT
    ERROR_VARIABLE CMAKE_GENERATION_OUTPUT
    )

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

PROJECT(dolfinx_pybind11)

find_package(xtensor REQUIRED)
find_package(Basix REQUIRED)
find_package(DOLFINX REQUIRED)

# Check if the Basix C++ library was compiled with xtensor SIMD
get_target_property(BASIX_DEFN Basix::basix INTERFACE_COMPILE_DEFINITIONS)
get_target_property(DOLFINX_DEFN dolfinx INTERFACE_COMPILE_DEFINITIONS)
if("XTENSOR_USE_XSIMD" IN_LIST BASIX_DEFN OR "XTENSOR_USE_XSIMD" IN_LIST DOLFINX_DEFN)
  find_package(xsimd REQUIRED)
endif()

# Set C++ standard before finding pybind11
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(pybind11 REQUIRED CONFIG HINTS ${PYBIND11_DIR} ${PYBIND11_ROOT}
  $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})

# Create the binding library
pybind11_add_module(cpp SHARED
  dolfinx/wrappers/dolfin.cpp
  dolfinx/wrappers/common.cpp
  dolfinx/wrappers/fem.cpp
  dolfinx/wrappers/generation.cpp
  dolfinx/wrappers/geometry.cpp
  dolfinx/wrappers/graph.cpp
  dolfinx/wrappers/io.cpp
  dolfinx/wrappers/la.cpp
  dolfinx/wrappers/log.cpp
  dolfinx/wrappers/mesh.cpp
  dolfinx/wrappers/nls.cpp
  dolfinx/wrappers/refinement.cpp)

# Add srict compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  target_compile_options(cpp PRIVATE -Wall;-Werror;-pedantic)
endif()

# In Debug mode override pybind11 symbols visibility
# Symbols must be visible to backtrace_symbols() to produce nice logs
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  target_compile_options(cpp PRIVATE "-fvisibility=default")
endif()

# Add DOLFINx libraries and other config
target_link_libraries(cpp PRIVATE pybind11::module dolfinx)

# Add xsimd if the Basix C++ interface was compiled with it
if("XTENSOR_USE_XSIMD" IN_LIST BASIX_DEFN OR "XTENSOR_USE_XSIMD" IN_LIST DOLFINX_DEFN)
  target_link_libraries(cpp PRIVATE xsimd)
endif()

# Add to CMake search path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Check for petsc4py
find_package(PETSc4py REQUIRED)
if (PETSC4PY_FOUND)
  target_include_directories(cpp PRIVATE ${PETSC4PY_INCLUDE_DIRS})
endif()

# Check for mpi4py
find_package(MPI4PY REQUIRED)
if (MPI4PY_FOUND)
  target_include_directories(cpp PRIVATE ${MPI4PY_INCLUDE_DIR})
  target_compile_definitions(cpp PRIVATE HAS_PYBIND11_MPI4PY)
endif()

=== cpp/demo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(dolfinx-demos)

# Find DOLFINx config file
find_package(Basix REQUIRED)
find_package(DOLFINX REQUIRED)

# Enable testing
enable_testing()

# Macro to add demos. Some subdirectories might be skipped because demos may
# not be running in both real and complex modes.
macro(add_demo_subdirectory subdir)
  if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${subdir})
    add_subdirectory(${subdir})
  endif()
endmacro(add_demo_subdirectory)

# Add demos
add_demo_subdirectory(poisson)
add_demo_subdirectory(hyperelasticity)

=== cpp/dolfinx/CMakeLists.txt ===
#------------------------------------------------------------------------------
include(GNUInstallDirs)

#------------------------------------------------------------------------------
# Configure the dolfinx/common/version.h file

# NOTE: This modifies a file in the source directory, which probably isn't good
configure_file(${DOLFINX_SOURCE_DIR}/dolfinx/common/version.h.in
  ${DOLFINX_SOURCE_DIR}/dolfinx/common/version.h @ONLY)

#------------------------------------------------------------------------------
# Delcare the library (target)

add_library(dolfinx)

#------------------------------------------------------------------------------
# Add source files to the target

set(DOLFINX_DIRS common fem generation geometry graph io la mesh nls refinement)

install(FILES dolfinx.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT Development)

# Add source to dolfinx target, and get sets of header files
foreach(DIR ${DOLFINX_DIRS})
  add_subdirectory(${DIR})
endforeach()

# Set target include location (for build and installed)
target_include_directories(dolfinx PUBLIC
                           $<INSTALL_INTERFACE:include>
                           "$<BUILD_INTERFACE:${DOLFINX_SOURCE_DIR};${DOLFINX_SOURCE_DIR}/dolfinx>")

#------------------------------------------------------------------------------
# Set target properties

set_target_properties(dolfinx PROPERTIES
  VERSION ${DOLFINX_VERSION}
  SOVERSION ${DOLFINX_VERSION_MAJOR}.${DOLFINX_VERSION_MINOR})

# Add git revision flag to the one affected file
set_source_files_properties(common/defines.cpp PROPERTIES
  COMPILE_DEFINITIONS "UFC_SIGNATURE=\"${UFC_SIGNATURE}\";DOLFINX_GIT_COMMIT_HASH=\"${GIT_COMMIT_HASH}\"")

#------------------------------------------------------------------------------
# Set compiler options and defintions

# Set 'Developer' build type flags
target_compile_options(dolfinx PRIVATE $<$<CONFIG:Developer>:${DOLFINX_CXX_DEVELOPER_FLAGS}>)

# Set debug definitions (private)
target_compile_definitions(dolfinx PRIVATE $<$<OR:$<CONFIG:Debug>,$<CONFIG:Developer>>:DEBUG>)

# Add version to definitions (public)
target_compile_definitions(dolfinx PUBLIC DOLFINX_VERSION="${DOLFINX_VERSION}")

#------------------------------------------------------------------------------
# Add include directories and libraries of required packages

# UFC
target_include_directories(dolfinx SYSTEM PUBLIC ${UFC_INCLUDE_DIRS})

# Basix
target_link_libraries(dolfinx PUBLIC Basix::basix)

# xtensor
target_link_libraries(dolfinx PUBLIC xtl)
target_link_libraries(dolfinx PUBLIC xtensor)
target_link_libraries(dolfinx PRIVATE xtensor-blas)
if("XTENSOR_USE_XSIMD" IN_LIST BASIX_DEFN)
  target_link_libraries(dolfinx PUBLIC xsimd)
endif()
if(XTENSOR_OPTIMIZE)
  target_link_libraries(dolfinx PUBLIC xtensor::optimize)
endif()

# Boost
target_link_libraries(dolfinx PUBLIC Boost::headers)
target_link_libraries(dolfinx PUBLIC Boost::timer)
target_link_libraries(dolfinx PRIVATE Boost::filesystem)

# MPI
target_link_libraries(dolfinx PUBLIC MPI::MPI_CXX)

# PETSc
target_link_libraries(dolfinx PUBLIC PETSC::petsc)
target_link_libraries(dolfinx PRIVATE PETSC::petsc_static)

# HDF5
if (TARGET hdf5::hdf5)
  target_link_libraries(dolfinx PUBLIC hdf5::hdf5)
else()
  # This is the old-style CMake (3.18 and earlier), remove when no
  # longer supporting older CMake
  target_compile_definitions(dolfinx PUBLIC ${HDF5_DEFINITIONS})
  target_link_libraries(dolfinx PUBLIC ${HDF5_C_LIBRARIES})
  target_include_directories(dolfinx SYSTEM PUBLIC ${HDF5_INCLUDE_DIRS})
endif()

# SCOTCH
target_link_libraries(dolfinx PRIVATE ${SCOTCH_LIBRARIES})
target_include_directories(dolfinx SYSTEM PRIVATE ${SCOTCH_INCLUDE_DIRS})

#------------------------------------------------------------------------------
# Optional packages

# SLEPC
if (DOLFINX_ENABLE_SLEPC AND SLEPC_FOUND)
  target_compile_definitions(dolfinx PUBLIC HAS_SLEPC)
  target_link_libraries(dolfinx PUBLIC SLEPC::slepc)
  target_link_libraries(dolfinx PRIVATE SLEPC::slepc_static)
endif()

# ParMETIS
if (DOLFINX_ENABLE_PARMETIS AND PARMETIS_FOUND)
  target_compile_definitions(dolfinx PUBLIC HAS_PARMETIS)
  target_link_libraries(dolfinx PRIVATE ${PARMETIS_LIBRARIES})
  target_include_directories(dolfinx SYSTEM PRIVATE ${PARMETIS_INCLUDE_DIRS})
endif()

# KaHIP
if (DOLFINX_ENABLE_KAHIP AND KAHIP_FOUND)
  target_compile_definitions(dolfinx PUBLIC HAS_KAHIP)
  target_link_libraries(dolfinx PRIVATE ${KAHIP_LIBRARIES})
  target_include_directories(dolfinx SYSTEM PRIVATE ${KAHIP_INCLUDE_DIRS})
endif()

#------------------------------------------------------------------------------
# Install dolfinx library and header files

install(TARGETS dolfinx
  EXPORT DOLFINXTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )

# Generate DOLFINTargets.cmake
install(EXPORT DOLFINXTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dolfinx)

# Install the header files
foreach(DIR ${DOLFINX_DIRS})
  install(FILES ${HEADERS_${DIR}} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx/${DIR}
    COMPONENT Development)
endforeach()

#------------------------------------------------------------------------------
# Generate CMake config files (DOLFINXConfig{,Version}.cmake)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfigVersion.cmake
  VERSION ${DOLFINX_VERSION}
  COMPATIBILITY ExactVersion)

configure_package_config_file(${DOLFINX_SOURCE_DIR}/cmake/templates/DOLFINXConfig.cmake.in
${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfig.cmake
INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dolfinx)

# Install CMake helper files
install(
  FILES
  ${CMAKE_SOURCE_DIR}/cmake/modules/FindPETSc.cmake
  ${CMAKE_SOURCE_DIR}/cmake/modules/FindSLEPc.cmake
  ${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfig.cmake
  ${CMAKE_BINARY_DIR}/dolfinx/DOLFINXConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dolfinx
  COMPONENT Development)

#------------------------------------------------------------------------------
# Generate pkg-config file and install it

# Define packages that should be required by pkg-config file
set(PKG_REQUIRES "")

# Get link libraries and includes
get_target_property(PKGCONFIG_DOLFINX_TARGET_LINK_LIBRARIES dolfinx INTERFACE_LINK_LIBRARIES)
get_target_property(PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES dolfinx INTERFACE_SYSTEM_INCLUDE_DIRECTORIES)

# Add imported targets to lists for creating pkg-config file
set(PKGCONFIG_DOLFINX_LIBS)
foreach(_target ${PKGCONFIG_DOLFINX_TARGET_LINK_LIBRARIES})

  if ("${_target}" MATCHES "^[^<>]+$")  # Skip "$<foo...>", which we get with static libs

    if ("${_target}" MATCHES "^.*::.*$")
      # Get include paths
      get_target_property(_inc_dirs ${_target} INTERFACE_INCLUDE_DIRECTORIES)
      if (_inc_dirs)
        list(APPEND PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES ${_inc_dirs})
      endif()

      # Get libraries
      get_target_property(_libs ${_target} INTERFACE_LINK_LIBRARIES)
      if (_libs)
        list(APPEND PKGCONFIG_DOLFINX_LIBS ${_libs})
      endif()

    else()
      # 'regular' libs, i.e. not imported targets
      list(APPEND PKGCONFIG_DOLFINX_LIBS ${_target})
    endif()

    # Special handling for compiled Boost imported targets
    if (("${_target}" MATCHES "^.*Boost::.*$") AND NOT "${_target}" STREQUAL "Boost::headers")
      get_target_property(_libs ${_target} IMPORTED_LOCATION_RELEASE)
      if (_libs)
        list(APPEND PKGCONFIG_DOLFINX_LIBS ${_libs})
      endif()
    endif()

  endif()

endforeach()

# Join include lists and remove duplicates
list(REMOVE_DUPLICATES PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES)
list(REMOVE_DUPLICATES PKGCONFIG_DOLFINX_LIBS)

# Convert include dirs to -I<incdir> form
foreach(_inc_dir ${PKGCONFIG_DOLFINX_INCLUDE_DIRECTORIES})
  set(PKG_INCLUDES "-I${_inc_dir} ${PKG_INCLUDES}")
endforeach()

# Get dolfinx definitions
get_target_property(PKG_DOLFINX_DEFINITIONS dolfinx INTERFACE_COMPILE_DEFINITIONS)
set(PKG_DEFINITIONS)
foreach(_def ${PKG_DOLFINX_DEFINITIONS})
  set(PKG_DEFINITIONS "${PKG_DEFINITIONS} -D${_def}")
endforeach()

# Get basix definitions (this is required to propagate Basix definition
# to the pkg-config file, in the future Basix should create its own
# basix.pc file, see https://github.com/FEniCS/basix/issues/204)
get_target_property(PKG_BASIX_DEFINITIONS Basix::basix INTERFACE_COMPILE_DEFINITIONS)
foreach(_def ${PKG_BASIX_DEFINITIONS})
  set(PKG_DEFINITIONS "${PKG_DEFINITIONS} -D${_def}")
endforeach()

# Convert compiler flags and definitions into space separated strings
string(REPLACE ";" " " PKG_CXXFLAGS "${CMAKE_CXX_FLAGS}")
string(REPLACE ";" " " PKG_LINKFLAGS "${CMAKE_EXE_LINKER_FLAGS}")

# Convert libraries to -L<libdir> -l<lib> form
foreach(_lib ${PKGCONFIG_DOLFINX_LIBS})
  # Add -Wl,option directives
  if ("${_lib}" MATCHES "-Wl,[^ ]*")
    set(PKG_LINKFLAGS "${_lib} ${PKG_LINKFLAGS}")
  else()
    get_filename_component(_path ${_lib} DIRECTORY)
    get_filename_component(_name ${_lib} NAME_WE)
    string(REPLACE "lib" "" _name "${_name}")

    # Add libraries that matches the form -L<libdir> -l<lib>
    if (NOT "${_path}" STREQUAL "")
      set(PKG_LINKFLAGS "-L${_path} -l${_name} ${PKG_LINKFLAGS}")
    endif()
  endif()
endforeach()

# Remove duplicated link flags
separate_arguments(PKG_LINKFLAGS)
list(REMOVE_DUPLICATES PKG_LINKFLAGS)
string(REPLACE ";" " " PKG_LINKFLAGS "${PKG_LINKFLAGS}")

# Add additional link flags
foreach(_linkflag ${DOLFINX_LINK_FLAGS})
  set(PKG_LINKFLAGS "${PKG_LINKFLAGS} ${_linkflag}")
endforeach()

# Boost include dir (used as pkg-config variable)
get_target_property(BOOST_INCLUDE_DIR Boost::headers INTERFACE_INCLUDE_DIRECTORIES)

# Configure and install pkg-config file
configure_file(${DOLFINX_SOURCE_DIR}/cmake/templates/dolfinx.pc.in ${CMAKE_BINARY_DIR}/dolfinx.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/dolfinx.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT Development
  )
#------------------------------------------------------------------------------

=== cpp/cmake/post-install/CMakeLists.txt ===
install(CODE "MESSAGE(
\"----------------------------------------------------------------------------
DOLFINx has now been installed in

    ${CMAKE_INSTALL_PREFIX}

and demo programs have been installed in

    ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/dolfinx/demo

Don't forget to update your environment variables. This can be done
easily using the helper file 'dolfinx.conf' which sets the appropriate
variables (for users of the Bash shell).

To update your environment variables, run the following command:

    source ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/dolfinx/dolfinx.conf

----------------------------------------------------------------------------\")")

=== cpp/dolfinx/common/CMakeLists.txt ===
set(HEADERS_common
  ${CMAKE_CURRENT_SOURCE_DIR}/defines.h
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_common.h
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_doc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/IndexMap.h
  ${CMAKE_CURRENT_SOURCE_DIR}/init.h
  ${CMAKE_CURRENT_SOURCE_DIR}/log.h
  ${CMAKE_CURRENT_SOURCE_DIR}/loguru.hpp
  ${CMAKE_CURRENT_SOURCE_DIR}/sort.h
  ${CMAKE_CURRENT_SOURCE_DIR}/MPI.h
  ${CMAKE_CURRENT_SOURCE_DIR}/subsystem.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Table.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Timer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/TimeLogger.h
  ${CMAKE_CURRENT_SOURCE_DIR}/TimeLogManager.h
  ${CMAKE_CURRENT_SOURCE_DIR}/array2d.h
  ${CMAKE_CURRENT_SOURCE_DIR}/math.h
  ${CMAKE_CURRENT_SOURCE_DIR}/timing.h
  ${CMAKE_CURRENT_SOURCE_DIR}/types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/UniqueIdGenerator.h
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.h
  ${CMAKE_CURRENT_SOURCE_DIR}/version.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/defines.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/IndexMap.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/init.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/log.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/MPI.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/subsystem.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Table.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Timer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/TimeLogger.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/TimeLogManager.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/timing.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/UniqueIdGenerator.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
)

=== cpp/dolfinx/fem/CMakeLists.txt ===
set(HEADERS_fem
  ${CMAKE_CURRENT_SOURCE_DIR}/Constant.h
  ${CMAKE_CURRENT_SOURCE_DIR}/CoordinateElement.h
  ${CMAKE_CURRENT_SOURCE_DIR}/DirichletBC.h
  ${CMAKE_CURRENT_SOURCE_DIR}/DofMap.h
  ${CMAKE_CURRENT_SOURCE_DIR}/ElementDofLayout.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Expression.h
  ${CMAKE_CURRENT_SOURCE_DIR}/FiniteElement.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Form.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Function.h
  ${CMAKE_CURRENT_SOURCE_DIR}/FunctionSpace.h
  ${CMAKE_CURRENT_SOURCE_DIR}/assembler.h
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_matrix_impl.h
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_scalar_impl.h
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_vector_impl.h
  ${CMAKE_CURRENT_SOURCE_DIR}/discreteoperators.h
  ${CMAKE_CURRENT_SOURCE_DIR}/dofmapbuilder.h
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_fem.h
  ${CMAKE_CURRENT_SOURCE_DIR}/interpolate.h
  ${CMAKE_CURRENT_SOURCE_DIR}/petsc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/sparsitybuild.h
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/DirichletBC.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/CoordinateElement.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/DofMap.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/ElementDofLayout.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/FiniteElement.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/FunctionSpace.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/discreteoperators.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/dofmapbuilder.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/interpolate.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/petsc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/sparsitybuild.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
)

=== cpp/dolfinx/generation/CMakeLists.txt ===
set(HEADERS_generation
  ${CMAKE_CURRENT_SOURCE_DIR}/BoxMesh.h
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_generation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/IntervalMesh.h
  ${CMAKE_CURRENT_SOURCE_DIR}/RectangleMesh.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/BoxMesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/IntervalMesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/RectangleMesh.cpp
)

=== cpp/dolfinx/graph/CMakeLists.txt ===
set(HEADERS_graph
  ${CMAKE_CURRENT_SOURCE_DIR}/AdjacencyList.h
  ${CMAKE_CURRENT_SOURCE_DIR}/boostordering.h
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_graph.h
  ${CMAKE_CURRENT_SOURCE_DIR}/partitioners.h
  ${CMAKE_CURRENT_SOURCE_DIR}/partition.h
  ${CMAKE_CURRENT_SOURCE_DIR}/scotch.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/boostordering.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/partitioners.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/partition.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/scotch.cpp
)

=== cpp/dolfinx/io/CMakeLists.txt ===
set(HEADERS_io
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_io.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cells.h
  ${CMAKE_CURRENT_SOURCE_DIR}/HDF5Interface.h
  ${CMAKE_CURRENT_SOURCE_DIR}/pugiconfig.hpp
  ${CMAKE_CURRENT_SOURCE_DIR}/pugixml.hpp
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.h
  ${CMAKE_CURRENT_SOURCE_DIR}/VTKFile.h
  ${CMAKE_CURRENT_SOURCE_DIR}/XDMFFile.h
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_function.h
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_mesh.h
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_meshtags.h
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_read.h
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_utils.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/cells.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/HDF5Interface.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/pugixml.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/VTKFile.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/XDMFFile.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_function.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_mesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/xdmf_utils.cpp
)

=== cpp/dolfinx/mesh/CMakeLists.txt ===
set(HEADERS_mesh
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_mesh.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Mesh.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Geometry.h
  ${CMAKE_CURRENT_SOURCE_DIR}/Topology.h
  ${CMAKE_CURRENT_SOURCE_DIR}/MeshTags.h
  ${CMAKE_CURRENT_SOURCE_DIR}/cell_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/graphbuild.h
  ${CMAKE_CURRENT_SOURCE_DIR}/permutationcomputation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/topologycomputation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/Mesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Geometry.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/Topology.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/cell_types.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/graphbuild.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/permutationcomputation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/topologycomputation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
)

=== cpp/dolfinx/nls/CMakeLists.txt ===
set(HEADERS_nls
  ${CMAKE_CURRENT_SOURCE_DIR}/dolfin_nls.h
  ${CMAKE_CURRENT_SOURCE_DIR}/NewtonSolver.h
  PARENT_SCOPE)

target_sources(dolfinx PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/NewtonSolver.cpp
)

=== debian/changelog ===
fenics-dolfinx (1:0.3.0-13build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 19:22:47 +0000

fenics-dolfinx (1:0.3.0-13) unstable; urgency=medium

  * debian patch use_std_filesystem_PR1980.patch applies upstream
    PR1980 to replace boost::filesystem references with std::filesystem
  * debian patch docs_local_mathjax.patch builds docs using local
    mathjax script

 -- Drew Parsons <dparsons@debian.org>  Wed, 02 Feb 2022 16:48:17 +0100

fenics-dolfinx (1:0.3.0-12) unstable; urgency=medium

  * debian/tests: skip python MPI unit tests on 32-bit systems.
    Some unit tests trigger an MPI_ABORT error for reasons unknown
    (possibly related to Bug#995599). Affects i386, armhf etc.

 -- Drew Parsons <dparsons@debian.org>  Wed, 03 Nov 2021 16:53:12 +0100

fenics-dolfinx (1:0.3.0-11) unstable; urgency=medium

  * drop debian patch compute_entity_32bit.patch. It did not fix the
    compute_entity failures on i386, armhf. Skip
    test_compute_closest_entity_2d instead.
  * Also skip test_cffi_assembly on 32-bit arches (cf. Bug#995599)

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Oct 2021 13:14:03 +0200

fenics-dolfinx (1:0.3.0-10) unstable; urgency=medium

  * fix tests on 32-bit systems
    - check numba.core.config.IS_32BITS in debian patch
      python_unit_test_32bit.patch when using numba parallel
    - skip mpi demos (helmholtz_2d, static_condensation_elasticity,
      poisson). cf. Bug#995599.
  * add debian patch compute_entity_32bit.patch to use int32_t
    consistently with declaration of _compute_nearest_entity
    (cf. python_unit_test_32bit.patch)

 -- Drew Parsons <dparsons@debian.org>  Tue, 26 Oct 2021 00:51:03 +0200

fenics-dolfinx (1:0.3.0-9) unstable; urgency=medium

  * switch libdolfinx-dev to Architecture: any, since xsimd
    configuration in cmake config files is arch-specific.
    - cmake files now returned to original arch-specific path
    - mark libdolfinx-dev as Multi-Arch: same
    - python3-dolfinx-real Depends: libdolfinx-dev (= ${binary:Version})
      Likewise python3-dolfinx-complex.
  * update debian/tests (autopkgtest)
    - use common test scripts for real and complex builds
    - enable python tests using numba where available
    - skip demo_poisson_mpi* C++ demos on 32-bit arches (Bug#995599)

 -- Drew Parsons <dparsons@debian.org>  Sun, 24 Oct 2021 14:56:23 +0200

fenics-dolfinx (1:0.3.0-8) unstable; urgency=medium

  * move libdolfinx-dev Recommends to Depends: ${xsimd:Depends},
    set to libxsimd-dev if dolfinx is configured to use xsimd
    (when xsimd is needed in dolfinx cmake config file)

 -- Drew Parsons <dparsons@debian.org>  Sun, 24 Oct 2021 01:30:25 +0200

fenics-dolfinx (1:0.3.0-7) unstable; urgency=medium

  * skip demo_poisson_mpi build-time tests on 32-bit systems.
    Segfaults on 32-bit systems, see Bug#995599.

 -- Drew Parsons <dparsons@debian.org>  Sat, 23 Oct 2021 17:50:49 +0200

fenics-dolfinx (1:0.3.0-6) unstable; urgency=medium

  * release dolfinx 0.3 to unstable. Closes: #996987.
  * drop xsimd support on arm64 (fails tests, see xtensor)

 -- Drew Parsons <dparsons@debian.org>  Sat, 23 Oct 2021 00:15:18 +0200

fenics-dolfinx (1:0.3.0-5) experimental; urgency=medium

  * debian patch MPI_remove_inplace_PR1738.patch adapts upstream
    PR1738 to drop use of MPI_IN_PLACE in MPI_Alltoall.

 -- Drew Parsons <dparsons@debian.org>  Tue, 12 Oct 2021 18:36:25 +0200

fenics-dolfinx (1:0.3.0-4) experimental; urgency=medium

  * reduce xsimd support to only those arches where it is known to
    work (amd64 arm64, and kfreebsd is untested). i.e. track basix
    and xtensor for xsimd-supporting arches.
    libxsimd-dev is available on some other arches such as i386, m68k,
    but no xsimd instructions are actually available there, which
    causes problems.
  * update debian/copyright
  * add :any to Build-Depends: python3-all-dev:any

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Oct 2021 18:34:15 +0200

fenics-dolfinx (1:0.3.0-3) experimental; urgency=medium

  * drop xsimd support from x86 [i386 hurd-i386 x32]
    tracking xtensor (and basix)

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Sep 2021 17:26:26 +0200

fenics-dolfinx (1:0.3.0-2) experimental; urgency=medium

  * versioned Depends: libxtensor-dev (>= 0.23.10~),
    libxtensor-blas-dev (>= 0.19.1~)
  * debian patch use_system_catch.patch uses system-installed catch2.
    Build-Depends: catch2. Closes: #993510.

 -- Drew Parsons <dparsons@debian.org>  Tue, 14 Sep 2021 15:21:57 +0200

fenics-dolfinx (1:0.3.0-1) experimental; urgency=medium

  * New upstream release
    - Depends: libbasix-dev (>= 0.3.0~), python3-ffcx (>= 1:0.3.0~)
    - lib soname bump to 0.3
  * Build-Depends: libxtensor-dev, libxtensor-blas-dev,
    python3-pip, python3-pybind11
  * use xtensor with XSIMD support on arches where available.
    Build-Depends: libxsimd-dev (>= 7.4.4~)
     [amd64 arm64 i386 hurd-i386 kfreebsd-any m68k sh4 x32]
    arch:all libdolfinx-dev Recommends: libxsimd-dev
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Mon, 13 Sep 2021 18:38:34 +0200

fenics-dolfinx (1:0.1.0-1) experimental; urgency=medium

  * update source package name to fenics-dolfinx
    - update Vcs salsa paths to fenics-dolfinx
    - remove upstream/signing-key.asc
      (upstream PGP signatures no longer provided)
  * first official upstream release
    - released as 0.1.0. Raise epoch to 1: to set higher than 2019.2.0
    - update library package names to libdolfinx-{real,complex}0.1
    - update individual versioned Depends:
        python3-all-dev (>= 3.7~),
        libbasix-dev (>= 0.1.0~),
        python3-ffcx (>= 1:0.1.0~), python3-ffcx (<< 1:0.2.0),
        python3-ufl (>= 2021.1.0~), python3-ufl (<< 2021.2.0)
    - use epoch with next dolfinx version (in libdolfinx-dev)
      i.e. libdolfinx-dev Depends: libdolfinx-real-dev (<< 1:0.2~)



=== debian/control ===
Source: fenics-dolfinx
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Drew Parsons <dparsons@debian.org>
Build-Depends:
 cmake (>= 3.12),
 debhelper-compat (= 13),
 dh-python,
 gfortran,
 catch2,
 chrpath,
 libbasix-dev (>= 0.3.0~), python3-basix,
 libboost-chrono-dev,
 libboost-dev (>= 1.70),
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libeigen3-dev (>= 3.2.90),
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 mpi-default-dev,
 libpetsc-real-dev (>= 3.10), libpetsc-complex-dev (>= 3.10),
 libslepc-real-dev (>= 3.10), libslepc-complex-dev (>= 3.10),
 libxtensor-dev (>= 0.23.10~), libxtensor-blas-dev (>= 0.19.1~),
 libxsimd-dev (>= 7.4.4~) [amd64 kfreebsd-any],
 python3-setuptools,
 python3-petsc4py, python3-petsc4py-real, python3-petsc4py-complex,
 python3-slepc4py, python3-slepc4py-real, python3-slepc4py-complex,
 pkg-config,
 python3-all-dev:any (>= 3.7~),
 python3-cffi,
 python3-pkg-resources,
 python3-ffcx (>= 1:0.3.0~), python3-ffcx (<< 1:0.4.0),
 python3-ufl (>= 2021.1.0~), python3-ufl (<< 2021.2.0),
 python3-mpi4py,
 python3-numpy,
 python3-pip,
 python3-ply,
 python3-pybind11 (>= 2.2.0),
 python3-sphinx
Build-Depends-Indep:
 doxygen,
 graphviz,
 libjs-mathjax,
 libjs-modernizr,
 python3-sphinx-rtd-theme
Standards-Version: 4.6.0
Homepage: http://fenicsproject.org
Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-dolfinx.git
Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-dolfinx

Package: libdolfinx-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfinx-real-dev (>= ${source:Version}) | libdolfinx-complex-dev (>= ${source:Version}),
 libdolfinx-real-dev (<< ${dolfinx:Next-Upstream-Version}) | libdolfinx-complex-dev (<< ${dolfinx:Next-Upstream-Version}),
 cmake (>= 3.12),
 g++ | c++-compiler,
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 pkg-config,
 python3-ffcx (>= 1:0.3.0~), python3-ffcx (<< 1:0.4.0),
 libxtensor-dev (>= 0.23.10~),
 libxsimd-dev (>= 7.4.4~) [amd64 kfreebsd-any],
 ${misc:Depends}
Conflicts:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Replaces:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Description: Shared links and header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the common development files and depends on
 the real or complex development package.
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by libdolfin-dev.


Package: libdolfinx-real-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfinx-real0.3 (= ${binary:Version}),
 ${petsc:Depends},
 ${misc:Depends}
Recommends: libdolfinx-dev
Description: Shared links and header files for DOLFIN (real numbers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for the real number build.
 .
 This is the next-generation version of DOLFIN-X.
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-complex-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfinx-complex0.3 (= ${binary:Version}),
 ${petsc-complex:Depends},
 ${misc:Depends}
Recommends: libdolfinx-dev
Description: Shared links and header files for DOLFIN (complex numbers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for the complex number build.
 .
 This is the next-generation version of DOLFIN-).
 The legacy version of DOLFIN is provided by libdolfin-dev.

Package: libdolfinx-real0.3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfinx-doc, python3-dolfinx
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with real number support.

Package: libdolfinx-complex0.3
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfinx-doc, python3-dolfinx
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries with complex number support.

Package: python3-dolfinx
Section: python
Architecture: any
Multi-Arch: same
Depends: python3-dolfinx-real | python3-dolfinx-complex,
 python3:any,
 ${misc:Depends},
 ${python3:Depends}
Suggests: dolfinx-doc
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by python3-dolfin.
 .
 This is a base package depending on the dolfinx packages with
 real or complex number support. By default the version built against
 the preferred version of PETSc in /usr/lib/petsc is selected, but the
 alternative version can be selected by setting the environment
 variable PETSC_DIR.


Package: python3-dolfinx-real
Section: python
Architecture: any
Depends:
 libdolfinx-dev (= ${binary:Version}),
 libdolfinx-real0.3 (= ${binary:Version}),
 python3-ffcx (>= 1:0.3.0~), python3-ffcx (<< 1:0.4.0),
 python3-ufl (>= 2021.1.0~), python3-ufl (<< 2021.2.0),
 python3-cffi,
 python3-mpi4py,
 python3-numpy,
 python3-ply,
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 python3-scipy,
 python3-six,
 python3-sympy,
 ${python3-petsc4py-real:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: python3-dolfinx
Suggests: dolfinx-doc
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3).
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN is provided by python3-dolfin.

Package: python3-dolfinx-complex
Section: python
Architecture: any
Depends:
 libdolfinx-dev (= ${binary:Version}),
 libdolfinx-complex0.3 (= ${binary:Version}),
 python3-ffcx (>= 1:0.3.0~), python3-ffcx (<< 1:0.4.0),
 python3-ufl (>= 2021.1.0~), python3-ufl (<< 2021.2.0),
 python3-cffi,
 python3-mpi4py,
 python3-numpy,
 python3-ply,
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 python3-scipy,
 python3-six,
 python3-sympy,
 ${python3-petsc4py-complex:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: python3-dolfinx
Suggests: dolfinx-doc
Description: Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3).
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The legacy version of DOLFIN (without complex number support)
 is provided by python3-dolfin.

Package: dolfinx-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends},
 libjs-mathjax
Recommends:
 libdolfinx-dev (>= ${source:Version}),
 python3-dolfinx (>= ${source:Version}),
 python3-matplotlib
Suggests: cmake (>= 2.8.0), python3-numba
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains documentation and demo programs for DOLFIN-X.
 .
 This is the next-generation version of libdolfinx-dev (DOLFIN-X).
 The documentation for the legacy version of DOLFIN is provided
 by dolfin-doc.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/architecture.mk

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_EPOCH := $(shell echo $(DEB_VERSION) | cut -d: -f1)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

DOLFINX_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
DOLFINX_MAJOR_VERSION=$(shell echo $(DOLFINX_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
DOLFINX_MINOR_VERSION=$(shell echo $(DOLFINX_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
DOLFINX_VERSION=$(DOLFINX_MAJOR_VERSION).$(DOLFINX_MINOR_VERSION)
DOLFINX_NEXT_VERSION=$(DEB_EPOCH):$(DOLFINX_MAJOR_VERSION).$(shell echo $$(( $(DOLFINX_MINOR_VERSION) + 1 )) )

# dolfinx depends on the pybind11 version it was built against,
# if pybind11.h will be used in C++ code fragments in python scripts.
# But pybind11 follows semantic versioning, so should have backwards compatibility
# with minor and patch version updates.
# Extract pybind11 version from pybind11-dev
PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
# extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
PYBIND11_X_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\([^.]*\).*/\1/")
PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
PYBIND11_VERSION=$(PYBIND11_X_Y_VERSION)
PYBIND11_NEXT_VERSION=$(shell echo $$(( $(PYBIND11_X_VERSION) + 1 )) )

# Allow test programs that use OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_btl_base_warn_component_unused=0

include /usr/share/mpi-default-dev/debian_defaults
ENABLE_MPI=ON
ifeq ($(findstring $(DEB_BUILD_ARCH),$(OPENMPI_ARCHITECTURES)),)
MPIEXEC_PARAMS=
else
MPIEXEC_PARAMS=--oversubscribe
endif

DOLFINX_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS)

BUILDDIR_REAL = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)-real
BUILDDIR_COMPLEX = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)-complex

NPROC := $(shell nproc)
PARALLEL = $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
N_CPU    = $(or $(PARALLEL),$(NPROC),1)
# MPI tests are set up to run on 3 processes. Spread them leanly over the available processors (don't have more than 2 tests using one processor).
# e.g. run 1 MPI test at a time over 1-3 processors, or 2 tests at a time over 4-6 processors, or 3 tests over 7-9 processors, etc.
N_MPI := 3
N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )

ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

# demo_poisson_mpi segfaults on 32-bit systems, see Bug#995599
ifeq (32,$(DEB_HOST_ARCH_BITS))
  SKIP_TEST_LIST = demo_poisson_mpi_2 demo_poisson_mpi_3
endif

# some arches just aren't keeping up at all, and fail non-MPI tests
ARCH_SKIP_ALL_TESTS_LIST = mips64el hurd-i386 m68k sh4

# extract PETSc version from petsc-dev
PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
# extract the current PETSc version
PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
# "Major" version is the first number in the upstream version (major.minor.release)
PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
# "Minor" version is the second number in the upstream version (major.minor.release)
PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
PETSC_VERSION=$(PETSC_MAJOR_VERSION).$(PETSC_MINOR_VERSION)
PETSC_VERSION_NEXT=$(shell echo $(PETSC_MAJOR_VERSION).$$(($(PETSC_MINOR_VERSION)+1)))

SLEPC_UPSTREAM_VERSION=$(shell pkg-config --modversion SLEPc)
# SLEPc version must match PETSc
SLEPC_VERSION=$(PETSC_VERSION)
SLEPC_VERSION_NEXT=$(PETSC_VERSION_NEXT)

PETSC_DIR_BASE=/usr/lib/petscdir/petsc$(PETSC_VERSION)/$(DEB_HOST_MULTIARCH)
SLEPC_DIR_BASE=/usr/lib/slepcdir/slepc$(SLEPC_VERSION)/$(DEB_HOST_MULTIARCH)
export PETSC_DIR_REAL=$(PETSC_DIR_BASE)-real
SLEPC_DIR_REAL=$(SLEPC_DIR_BASE)-real
export PETSC_DIR_COMPLEX=$(PETSC_DIR_BASE)-complex
SLEPC_DIR_COMPLEX=$(SLEPC_DIR_BASE)-complex

# libxsimd-dev is available on some arches such as i386, m68k,
# but no xsimd instructions are actually available which can cause problems,
# or xsimd support fails tests
# (see also xsimd support in basix and xtensor)
# So explicitly switch xsimd support off except for arches where it is known to work.
XSIMD_ARCH_LIST := amd64 kfreebsd
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(XSIMD_ARCH_LIST)$(space)))
  XSIMD_CONFIG=-DXTENSOR_USE_XSIMD=ON
else
  XSIMD_CONFIG=-DXTENSOR_USE_XSIMD=OFF
endif

DEB_CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)

CMAKE_OPTS := \
	-D CMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D DOLFINX_ENABLE_TRILINOS:BOOL=OFF \
	-D DOLFINX_ENABLE_HDF5:BOOL=ON \
	-D HDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5pcc \
	-D DOLFINX_ENABLE_PARMETIS:BOOL=OFF \
	-D DOLFINX_ENABLE_SCOTCH:BOOL=ON \
	-D DOLFINX_ENABLE_DOCS:BOOL=OFF \
	-D DOLFINX_ENABLE_MPI:BOOL=$(ENABLE_MPI) \
	-D MPIEXEC_PARAMS:STRING="$(MPIEXEC_PARAMS)" \
	-D CMAKE_CXX_FLAGS:STRING="-fpermissive" \
	-D DOLFINX_EXTRA_CXX_FLAGS:STRING="$(DEB_CXXFLAGS)" \
	$(XSIMD_CONFIG)

%:
	dh $@ --buildsystem=cmake --with python3,sphinxdoc

override_dh_compress:
	dh_compress -X.py -X.cpp -X.h -X.pdf -X.ufl

override_dh_auto_clean:
	dh_auto_clean --builddir=$(BUILDDIR_REAL)
	dh_auto_clean --builddir=$(BUILDDIR_COMPLEX)
	rm -f cpp/dolfinx/common/version.h \
	     cpp/demo/hyperelasticity/CMakeLists.txt \
	     cpp/demo/poisson/CMakeLists.txt

override_dh_auto_configure:
	PETSC_DIR=$(PETSC_DIR_REAL) SLEPC_DIR=$(SLEPC_DIR_REAL) dh_auto_configure --builddir=$(BUILDDIR_REAL) -- $(CMAKE_OPTS) $(CURDIR)/cpp
	PETSC_DIR=$(PETSC_DIR_COMPLEX) SLEPC_DIR=$(SLEPC_DIR_COMPLEX) dh_auto_configure --builddir=$(BUILDDIR_COMPLEX) -- $(CMAKE_OPTS) $(CURDIR)/cpp

override_dh_auto_build:
	PETSC_DIR=$(PETSC_DIR_REAL) SLEPC_DIR=$(SLEPC_DIR_REAL) dh_auto_build --builddir=$(BUILDDIR_REAL)
	PETSC_DIR=$(PETSC_DIR_COMPLEX) SLEPC_DIR=$(SLEPC_DIR_COMPLEX) dh_auto_build --builddir=$(BUILDDIR_COMPLEX)

override_dh_auto_test-arch:
	echo "Tests must be run after installation"

override_dh_auto_test-indep:

override_dh_auto_install-real:
	dh_auto_install --builddir=$(BUILDDIR_REAL) --destdir=debian/tmp-real
	for build in real; do \
	  for v in $(PYVERS); do \
	      cd python; \
	      PATH=$(CURDIR)/debian/tmp-$${build}/usr/bin:$$PATH \
	      PETSC_DIR=$(PETSC_DIR_BASE)-$${build} SLEPC_DIR=$(SLEPC_DIR_BASE)-$${build} \
	      CXXFLAGS="$(DEB_CXXFLAGS) -isystem $(CURDIR)/debian/tmp-$${build}/usr/include" \
	      VERBOSE=1 \
	      $$v setup.py build --build-base=build-$${build} install --root=$(CURDIR)/debian/tmp-$${build} --install-layout=deb; \
	      cd ..; \
	  done; \
	done

override_dh_auto_install-indep: override_dh_auto_install-real
	dh_auto_install -i --builddir=$(BUILDDIR_COMPLEX) --destdir=debian/tmp-complex
	(cd cpp/doc; doxygen)
	(cd python/doc; \
	  python3 ../demo/generate-demo-files.py; \
	  mkdir -p build/pkgconfig; \
	  cp $(CURDIR)/debian/tmp-real/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/dolfinx_real.pc build/pkgconfig; \
	  sed "s|prefix=/usr|prefix=$(CURDIR)/debian/tmp-real/usr|" -i build/pkgconfig/dolfinx_real.pc; \
	  PYTHONPATH=$(CURDIR)/debian/tmp-real/usr/lib/python3/dist-packages \
	    PKG_CONFIG_PATH=`pwd`/build/pkgconfig:$${PKG_CONFIG_PATH} \

=== debian/tests/control ===
Tests: test-dolfinx-cpp,
 test-dolfinx-cpp-complex,
Depends: @, @builddeps@,
Restrictions: allow-stderr

Tests: test-dolfinx-python-unittests,
 test-dolfinx-python-demos
Depends: @, @builddeps@,
	  python3-pytest,
	  python3-pytest-mpi,
	  python3-decorator,
	  python3-gmsh,
	  python3-matplotlib,
	  python3-numba [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64],
	  python3-scipy
Restrictions: allow-stderr

Tests: test-dolfinx-python-complex-unittests,
 test-dolfinx-python-complex-demos
Depends: @, @builddeps@,
	  python3-pytest,
	  python3-pytest-mpi,
	  python3-decorator,
	  python3-gmsh,
	  python3-matplotlib,
	  python3-numba [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x ppc64],
	  python3-scipy
Restrictions: allow-stderr
